#include "lib.h"

char **environ = (char **)ENVBASE;
static char *envend = (char *)(ENVBASE + BY2PG);

int
setenv(char *name, char *value)
{
  int argc = 0;
  int namelen = strlen(name);
  int vallen = strlen(value);
  char *bufptr = (char *)(environ + 33);

  if (name == NULL)
    return -E_INVAL;
  if (value == NULL) {
    delenv(name);
    return 0;
  }

  if (getenv(name))
    delenv(name);

  while (environ[argc]) {
    if (argc >= MAX_ENV_VARS)
      return -E_NO_MEM;
    bufptr = environ[argc++];
  }
  if (argc)
    bufptr = bufptr + strlen(bufptr) + 1;
  if ((bufptr + namelen + vallen + 2) > envend)
    return -E_NO_MEM;
  strcpy(bufptr, name);
  *(bufptr+namelen)= '=';
  strcpy(bufptr+namelen+1, value);
  environ[argc]=bufptr;
  environ[argc+1]=0;
  return 0;
}

char *
getenv(char *name)
{
  int argc;

  for (argc=0; environ[argc]; argc++) {
    if ((!strncmp(environ[argc], name, strlen(name))) &&
	(environ[argc][strlen(name)] = '=')) {
      return(&environ[argc][strlen(name)+1]);
    }
  }
  return NULL;
}

void
delenv(char *name)
{
  int found = -1;
  int end, argc;

  for (argc=0; environ[argc]; argc++) {
    if ((!strncmp(environ[argc], name, strlen(name))) &&
	(environ[argc][strlen(name)] = '=')) {
      found = argc;
    }
  }
  end = argc-1;
  if (found > -1) {
    for (argc=found; argc < end; argc++) {
      strcpy(environ[argc],environ[argc+1]);
      environ[argc+1] = environ[argc] + strlen(environ[argc]) + 1;
    }
    environ[argc] = 0;
  }
}
