#include "lib.h"
#include <stdio.h>

int flag[256];
static int debug = 0;

void
rm(char *path)
{
  int r, n;
  int fd;
  struct File f;
  char newpath[MAXPATHLEN];

  if (isdir(path)) {
    if (!flag['r']){
      fprintf(STDERR_FILE, "Can't remove a directory unless -r specified\n");
      exit();
    }
    if ((fd = open(path, O_RDONLY)) < 0)
      panic("open %s: %e", path, fd);
    while ((n = readn(fd, &f, sizeof f)) == sizeof f) {
      strcpy(newpath, path);
      strcat(newpath, f.f_name);
      if (f.f_type == FTYPE_DIR){
	rm(newpath);
      } else {
	remove(newpath);
      }
    }
    if (n > 0)
      panic("short read in directory %s", path);
    if (n < 0)
      panic("error reading directory %s: %e", path, n);
    close(n);
  }
  remove(path);
}


void
usage(void)
{
	fprintf(1, "usage: rm [-fr] [file...]\n");
	exit();
}

void
umain(int argc, char **argv)
{
	int i;

	ARGBEGIN{
	default:
		usage();
	case 'r':
	case 'f':
		flag[(u_char)ARGC()]++;
		break;
	}ARGEND
	   
	   if (debug)
	     fprintf(STDERR_FILE, "rm: begin\n");
	if (argc == 0)
	  usage();
	else {
	  for (i=0; i<argc; i++)
	    rm(argv[i]);
	}
}

