// String routines.  Not hardware optimized, but not shabby.

#include "lib.h"

int
strlen(const char *s)
{
	int n;

	for (n=0; *s; s++)
		n++;
	return n;
}

char*
strcpy(char *dst, const char *src)
{
	char *ret;

	ret = dst;
	while ((*dst++ = *src++) != 0)
		;
	return ret;
}

char *
strncpy(char *to, const char *from, size_t n)
{
  char *start = to;
 
  while (*from && n) {
    *to++ = *from++;
    n--;
  }
  
  return start;
}

const char*
strchr(const char *s, char c)
{
	for(; *s; s++)
		if(*s == c)
			return s;
	return 0;
}

const char * strrchr(const char * s, char c)
{
       const char *p = s + strlen(s);
       do {
           if (*p == (char)c)
               return (char *)p;
       } while (--p >= s);
       return NULL;
}

void
memset(void *v, const char c, u_int n)
{
	char *p;
	int m;

	p = v;
	m = n;
	while (--m >= 0)
		*p++ = c;
}

void
bzero(void *v, u_int n)
{
	char *p;
	int m;

	p = v;
	m = n;
	while (--m >= 0)
		*p++ = 0;
}

void
memcpy(void *dst, const void *src, u_int n)
{
	const char *s;
	char *d;
	int m;

	s = src;
	d = (char*)dst;
	m = n;
	while (--m >= 0)
		*d++ = *s++;
}

void
bcopy(const void *src, void *dst, u_int n)
{
  memcpy(dst,src,n);
}

int
strcmp(const char *p, const char *q)
{
	while (*p && *p == *q)
		p++, q++;
	if ((u_int)*p < (u_int)*q)
		return -1;
	if ((u_int)*p > (u_int)*q)
		return 1;
	return 0;
}

int strncmp(const char * cs,const char * ct,size_t count)
{
	register signed char __res = 0;

	while (count) {
		if ((__res = *cs - *ct++) != 0 || !*cs++)
			break;
		count--;
	}

	return __res;
}

char * 
strcat(char * dest, const char * src)
{
  char *tmp = dest;
  
  while (*dest)
    dest++;
  while ((*dest++ = *src++) != '\0')
    ;
  
  return tmp;
}
